DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Stepper - Step Template

JavaScript Stepper allows you to customize steps using the DevExtreme template engine. You can set custom markup for indicators including custom step shapes.

This demo uses the itemTemplate property to customize all steps in a JavaScript Stepper. For individual step customization, specify the items[].template property.

Backend API
$(() => { $('#customStepShape').dxStepper({ selectedIndex: 2, dataSource, linear: false, elementAttr: { 'aria-labelledby': 'label-customStepShape' }, itemTemplate(data) { return `<div class="dx-step-indicator"> <i class="dx-icon dx-icon-${data.icon}"></i> </div> <div class="dx-step-caption"> <div class="dx-step-label">${data.label}</div> ${data.optional ? '<div class="dx-step-optional-mark">(Optional)</div>' : ''} </div>`; }, }); $('#labelOnly').dxStepper({ selectedIndex: 2, dataSource, linear: false, elementAttr: { 'aria-labelledby': 'label-labelOnly' }, itemTemplate(data) { return `<div class='dx-step-caption'> <div class='dx-step-label'>${data.label}</div> </div>`; }, }); $('#iconOnly').dxStepper({ selectedIndex: 2, dataSource, linear: false, elementAttr: { 'aria-labelledby': 'label-iconOnly' }, itemTemplate(data) { return `<i class="dx-icon dx-icon-${data.icon}"></i>`; }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="label-customStepShape" class="stepper-label">Custom Step Shape</div> <div id="customStepShape"></div> <div id="label-labelOnly" class="stepper-label">Label Only</div> <div id="labelOnly"></div> <div id="label-iconOnly" class="stepper-label">Icon Only</div> <div id="iconOnly"></div> </div> </body> </html>
.demo-container { display: flex; flex-direction: column; align-items: center; justify-content: center; row-gap: 16px; height: 580px; min-width: 320px; } .stepper-label { font-weight: 600; } #customStepShape { margin-bottom: 64px; } #customStepShape .dx-step-indicator { border-radius: 4px; } #labelOnly { margin-bottom: 64px; align-items: center; } #labelOnly .dx-step { padding-inline: 2px; } #labelOnly .dx-step-content { padding-block: 4px; } #labelOnly .dx-step-caption { width: auto; max-width: 100%; } #labelOnly .dx-step-label { background-color: var(--dx-color-main-bg); padding-inline: 8px; } #labelOnly .dx-step.dx-state-focused .dx-step-caption { box-shadow: 0 0 0 2px var(--dx-color-main-bg), 0 0 0 4px var(--dx-color-primary), 0 0 0 8px var(--dx-color-main-bg); border-radius: 4px; } #iconOnly { align-items: center; } #iconOnly .dx-step-content { margin-block: 4px; } #iconOnly .dx-icon { box-sizing: content-box; padding: 6px; background-color: var(--dx-color-main-bg); } #iconOnly .dx-state-focused .dx-icon { box-shadow: 0 0 0 2px var(--dx-color-primary), 0 0 0 6px var(--dx-color-main-bg); border-radius: 4px; } #iconOnly :is(.dx-step-selected, .dx-step-completed) .dx-icon { color: var(--dx-color-primary); }
const dataSource = [{ text: 'A', label: 'Cart', icon: 'cart', }, { text: 'B', label: 'Shipping Info', icon: 'clipboardtasklist', }, { text: 'C', label: 'Promo Code', icon: 'gift', optional: true, }, { text: 'D', label: 'Checkout', icon: 'packagebox', }, { text: 'E', label: 'Ordered', icon: 'checkmarkcircle', }];

Backend API
import React from 'react';
import Stepper from 'devextreme-react/stepper';
import { steps } from './data.ts';
import CustomStepShape from './CustomStepShape.tsx';
import LabelOnly from './LabelOnly.tsx';
import IconOnly from './IconOnly.tsx';
export default function App() {
return (
<>
<div id="label-customStepShape" className="stepper-label">Custom Step Shape</div>
<Stepper
id="customStepShape"
elementAttr={{ 'aria-labelledby': 'label-customStepShape' }}
dataSource={steps}
defaultSelectedIndex={2}
linear={false}
itemRender={CustomStepShape}
/>
<div id="label-labelOnly" className="stepper-label">Label Only</div>
<Stepper
id="labelOnly"
elementAttr={{ 'aria-labelledby': 'label-labelOnly' }}
dataSource={steps}
defaultSelectedIndex={2}
linear={false}
itemRender={LabelOnly}
/>
<div id="label-iconOnly" className="stepper-label">Icon Only</div>
<Stepper
id="iconOnly"
elementAttr={{ 'aria-labelledby': 'label-iconOnly' }}
dataSource={steps}
defaultSelectedIndex={2}
linear={false}
itemRender={IconOnly}
/>
</>
);
}
import React from 'react';
import Stepper from 'devextreme-react/stepper';
import { steps } from './data.js';
import CustomStepShape from './CustomStepShape.js';
import LabelOnly from './LabelOnly.js';
import IconOnly from './IconOnly.js';
export default function App() {
return (
<>
<div
id="label-customStepShape"
className="stepper-label"
>
Custom Step Shape
</div>
<Stepper
id="customStepShape"
elementAttr={{ 'aria-labelledby': 'label-customStepShape' }}
dataSource={steps}
defaultSelectedIndex={2}
linear={false}
itemRender={CustomStepShape}
/>
<div
id="label-labelOnly"
className="stepper-label"
>
Label Only
</div>
<Stepper
id="labelOnly"
elementAttr={{ 'aria-labelledby': 'label-labelOnly' }}
dataSource={steps}
defaultSelectedIndex={2}
linear={false}
itemRender={LabelOnly}
/>
<div
id="label-iconOnly"
className="stepper-label"
>
Icon Only
</div>
<Stepper
id="iconOnly"
elementAttr={{ 'aria-labelledby': 'label-iconOnly' }}
dataSource={steps}
defaultSelectedIndex={2}
linear={false}
itemRender={IconOnly}
/>
</>
);
}
import React from 'react';
import { type StepperTypes } from 'devextreme-react/stepper';
export default function CustomStepShape(data: StepperTypes.Item) {
const { icon, label, optional } = data;
return (
<>
<div className="dx-step-indicator">
<i className={`dx-icon dx-icon-${icon}`}></i>
</div>
<div className="dx-step-caption">
<div className="dx-step-label">{label}</div>
{optional && <div className="dx-step-optional-mark">(Optional)</div>}
</div>
</>
);
}
import React from 'react';
interface IconOnlyProps {
icon: string;
}
export default function IconOnly({ icon }: IconOnlyProps) {
return (
<i className={`dx-icon dx-icon-${icon}`}></i>
);
}
import React from 'react';
interface LabelOnlyProps {
label: string;
}
export default function LabelOnly({ label }: LabelOnlyProps) {
return (
<div className="dx-step-caption">
<div className="dx-step-label">{label}</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.tsx';
themes.initialized(() => {
ReactDOM.render(
<App />,
document.getElementById('app'),
);
});
import type { StepperTypes } from 'devextreme-react/stepper';
export const steps: StepperTypes.Item[] = [{
text: 'A',
label: 'Cart',
icon: 'cart',
}, {
text: 'B',
label: 'Shipping Info',
icon: 'clipboardtasklist',
}, {
text: 'C',
label: 'Promo Code',
icon: 'gift',
optional: true,
}, {
text: 'D',
label: 'Checkout',
icon: 'packagebox',
}, {
text: 'E',
label: 'Ordered',
icon: 'checkmarkcircle',
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
export default function CustomStepShape(data) {
const { icon, label, optional } = data;
return (
<>
<div className="dx-step-indicator">
<i className={`dx-icon dx-icon-${icon}`}></i>
</div>
<div className="dx-step-caption">
<div className="dx-step-label">{label}</div>
{optional && <div className="dx-step-optional-mark">(Optional)</div>}
</div>
</>
);
}
import React from 'react';
export default function IconOnly({ icon }) {
return <i className={`dx-icon dx-icon-${icon}`}></i>;
}
import React from 'react';
export default function LabelOnly({ label }) {
return (
<div className="dx-step-caption">
<div className="dx-step-label">{label}</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.js';
themes.initialized(() => {
ReactDOM.render(<App />, document.getElementById('app'));
});
export const steps = [
{
text: 'A',
label: 'Cart',
icon: 'cart',
},
{
text: 'B',
label: 'Shipping Info',
icon: 'clipboardtasklist',
},
{
text: 'C',
label: 'Promo Code',
icon: 'gift',
optional: true,
},
{
text: 'D',
label: 'Checkout',
icon: 'packagebox',
},
{
text: 'E',
label: 'Ordered',
icon: 'checkmarkcircle',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#app {
display: flex;
flex-direction: column;
align-items: center;
justify-content: center;
row-gap: 16px;
height: 580px;
min-width: 320px;
}
.stepper-label {
font-weight: 600;
}
#customStepShape {
margin-bottom: 64px;
}
#customStepShape .dx-step-indicator {
border-radius: 4px;
}
#labelOnly {
margin-bottom: 64px;
align-items: center;
}
#labelOnly .dx-step {
padding-inline: 2px;
}
#labelOnly .dx-step-content {
padding-block: 4px;
}
#labelOnly .dx-step-caption {
width: auto;
max-width: 100%;
}
#labelOnly .dx-step-label {
background-color: var(--dx-color-main-bg);
padding-inline: 8px;
}
#labelOnly .dx-step.dx-state-focused .dx-step-caption {
box-shadow: 0 0 0 2px var(--dx-color-main-bg), 0 0 0 4px var(--dx-color-primary), 0 0 0 8px var(--dx-color-main-bg);
border-radius: 4px;
}
#iconOnly {
align-items: center;
}
#iconOnly .dx-step-content {
margin-block: 4px;
}
#iconOnly .dx-icon {
box-sizing: content-box;
padding: 6px;
background-color: var(--dx-color-main-bg);
}
#iconOnly .dx-state-focused .dx-icon {
box-shadow: 0 0 0 2px var(--dx-color-primary), 0 0 0 6px var(--dx-color-main-bg);
border-radius: 4px;
}
#iconOnly :is(.dx-step-selected, .dx-step-completed) .dx-icon {
color: var(--dx-color-primary);
}

Backend API
<div id="label-customStepShape" class="stepper-label">Custom Step Shape</div>
<dx-stepper
id="customStepShape"
[dataSource]="steps"
[selectedIndex]="2"
[linear]="false"
[elementAttr]="{ 'aria-labelledby': 'label-customStepShape' }"
>
<div *dxTemplate="let data of 'item'">
<div class="dx-step-indicator">
<i class="dx-icon" [class]="'dx-icon-' + data.icon"></i>
</div>
<div class="dx-step-caption">
<div class="dx-step-label">{{ data.label }}</div>
@if (data.optional) {
<div class="dx-step-optional-mark">(Optional)</div>
}
</div>
</div>
</dx-stepper>
<div id="label-labelOnly" class="stepper-label">Label Only</div>
<dx-stepper
id="labelOnly"
[dataSource]="steps"
[selectedIndex]="2"
[linear]="false"
[elementAttr]="{ 'aria-labelledby': 'label-labelOnly' }"
>
<div *dxTemplate="let data of 'item'">
<div class="dx-step-caption">
<div class="dx-step-label">{{ data.label }}</div>
</div>
</div>
</dx-stepper>
<div id="label-iconOnly" class="stepper-label">Icon Only</div>
<dx-stepper
id="iconOnly"
[dataSource]="steps"
[selectedIndex]="2"
[linear]="false"
[elementAttr]="{ 'aria-labelledby': 'label-iconOnly' }"
>
<div *dxTemplate="let data of 'item'">
<i class="dx-icon" [class]="'dx-icon-' + data.icon"></i>
</div>
</dx-stepper>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxStepperModule } from 'devextreme-angular';
import { type DxStepperTypes } from 'devextreme-angular/ui/stepper';
import { AppService } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxStepperModule,
],
})
export class AppComponent {
steps: DxStepperTypes.Item[];
constructor(private readonly appService: AppService) {
this.steps = this.appService.getSteps();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
AppService,
],
});
::ng-deep demo-app {
display: flex;
flex-direction: column;
align-items: center;
justify-content: center;
row-gap: 16px;
height: 580px;
min-width: 320px;
}
::ng-deep .stepper-label {
font-weight: 600;
}
::ng-deep #customStepShape {
margin-bottom: 64px;
}
::ng-deep #customStepShape .dx-step-indicator {
border-radius: 4px;
}
::ng-deep #labelOnly {
margin-bottom: 64px;
align-items: center;
}
::ng-deep #labelOnly .dx-step {
padding-inline: 2px;
}
::ng-deep #labelOnly .dx-step-content {
padding-block: 4px;
}
::ng-deep #labelOnly .dx-step-caption {
width: auto;
max-width: 100%;
}
::ng-deep #labelOnly .dx-step-label {
background-color: var(--dx-color-main-bg);
padding-inline: 8px;
}
::ng-deep #labelOnly .dx-step.dx-state-focused .dx-step-caption {
box-shadow: 0 0 0 2px var(--dx-color-main-bg), 0 0 0 4px var(--dx-color-primary), 0 0 0 8px var(--dx-color-main-bg);
border-radius: 4px;
}
::ng-deep #iconOnly {
align-items: center;
}
::ng-deep #iconOnly .dx-step-content {
margin-block: 4px;
}
::ng-deep #iconOnly .dx-icon {
box-sizing: content-box;
padding: 6px;
background-color: var(--dx-color-main-bg);
}
::ng-deep #iconOnly .dx-state-focused .dx-icon {
box-shadow: 0 0 0 2px var(--dx-color-primary), 0 0 0 6px var(--dx-color-main-bg);
border-radius: 4px;
}
::ng-deep #iconOnly .dx-step-selected .dx-icon,
::ng-deep #iconOnly .dx-step-completed .dx-icon {
color: var(--dx-color-primary);
}
import { Injectable } from '@angular/core';
import { type DxStepperTypes } from 'devextreme-angular/ui/stepper';
@Injectable({
providedIn: 'root',
})
export class AppService {
steps: DxStepperTypes.Item[] = [];
constructor() {
this.steps = [{
text: 'A',
label: 'Cart',
icon: 'cart',
},
{
text: 'B',
label: 'Shipping Info',
icon: 'clipboardtasklist',
},
{
text: 'C',
label: 'Promo Code',
icon: 'gift',
optional: true,
},
{
text: 'D',
label: 'Checkout',
icon: 'packagebox',
},
{
text: 'E',
label: 'Ordered',
icon: 'checkmarkcircle',
}];
}
getSteps(): DxStepperTypes.Item[] {
return this.steps;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Stepper - Step Template
Stepper allows you to customize steps using the DevExtreme template engine. You can set custom markup for indicators including custom step shapes.
This demo uses the itemTemplate property to customize all steps in a Stepper. For individual step customization, specify the items[].template property.
Backend API
<template>
<div
id="label-customStepShape"
class="stepper-label"
>Custom Step Shape</div>
<DxStepper
id="customStepShape"
:data-source="steps"
:selected-index="2"
:linear="false"
:element-attr="{ 'aria-labelledby': 'label-customStepShape' }"
>
<template #item="{ data }">
<div>
<div class="dx-step-indicator">
<i :class="'dx-icon dx-icon-' + data.icon"/>
</div>
<div class="dx-step-caption">
<div class="dx-step-label">{{ data.label }}</div>
<div
v-if="data.optional"
class="dx-step-optional-mark"
>(Optional)</div>
</div>
</div>
</template>
</DxStepper>
<div
id="label-labelOnly"
class="stepper-label"
>Label Only</div>
<DxStepper
id="labelOnly"
:data-source="steps"
:selected-index="2"
:linear="false"
:element-attr="{ 'aria-labelledby': 'label-labelOnly' }"
>
<template #item="{ data }">
<div>
<div class="dx-step-caption">
<div class="dx-step-label">{{ data.label }}</div>
</div>
</div>
</template>
</DxStepper>
<div
id="label-iconOnly"
class="stepper-label"
>Icon Only</div>
<DxStepper
id="iconOnly"
:data-source="steps"
:selected-index="2"
:linear="false"
:element-attr="{ 'aria-labelledby': 'label-iconOnly' }"
>
<template #item="{ data }">
<div>
<i :class="'dx-icon dx-icon-' + data.icon"/>
</div>
</template>
</DxStepper>
</template>
<script setup lang="ts">
import DxStepper from 'devextreme-vue/stepper';
import { steps } from './data.ts';
</script>
<style scoped>
#app {
display: flex;
flex-direction: column;
align-items: center;
justify-content: center;
row-gap: 16px;
height: 580px;
min-width: 320px;
}
.stepper-label {
font-weight: 600;
}
#customStepShape {
margin-bottom: 64px;
}
#customStepShape .dx-step-indicator {
border-radius: 4px;
}
#labelOnly {
margin-bottom: 64px;
align-items: center;
}
#labelOnly .dx-step {
padding-inline: 2px;
}
#labelOnly .dx-step-content {
padding-block: 4px;
}
#labelOnly .dx-step-caption {
width: auto;
max-width: 100%;
}
#labelOnly .dx-step-label {
background-color: var(--dx-color-main-bg);
padding-inline: 8px;
}
#labelOnly .dx-step.dx-state-focused .dx-step-caption {
box-shadow: 0 0 0 2px var(--dx-color-main-bg), 0 0 0 4px var(--dx-color-primary), 0 0 0 8px var(--dx-color-main-bg);
border-radius: 4px;
}
#iconOnly {
align-items: center;
}
#iconOnly .dx-step-content {
margin-block: 4px;
}
#iconOnly .dx-icon {
box-sizing: content-box;
padding: 6px;
background-color: var(--dx-color-main-bg);
}
#iconOnly .dx-state-focused .dx-icon {
box-shadow: 0 0 0 2px var(--dx-color-primary), 0 0 0 6px var(--dx-color-main-bg);
border-radius: 4px;
}
#iconOnly :is(.dx-step-selected, .dx-step-completed) .dx-icon {
color: var(--dx-color-primary);
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const steps = [{
text: 'A',
label: 'Cart',
icon: 'cart',
},
{
text: 'B',
label: 'Shipping Info',
icon: 'clipboardtasklist',
},
{
text: 'C',
label: 'Promo Code',
icon: 'gift',
optional: true,
},
{
text: 'D',
label: 'Checkout',
icon: 'packagebox',
},
{
text: 'E',
label: 'Ordered',
icon: 'checkmarkcircle',
}];
import { createApp } from 'vue';
import themes from 'devextreme/ui/themes';
import App from './App.vue';
themes.initialized(() => createApp(App).mount('#app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>